package com.vendor.burn.model;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.model.PCNetworkInfo;
import com.vendor.burn.model.config.BurnConfig;
import com.vendor.burn.model.define.IConfig;
import com.vendor.burn.preferences.FastbootPreferences;
import com.vendor.burn.utilitily.IPUtils;
import com.vendor.burn.utilitily.ToolUtils;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class BoardConfig implements IConfig {
  public static final String DIVIDEE_SYMBOLS1 = ",";
  
  public static final String DIVIDEE_SYMBOLS2 = ";";
  
  public static final List<PCNetworkInfo> pcNetworkInfoList = IPUtils.getPCNetworkInfo();
  
  private String mac;
  
  private String ip;
  
  private String subnetMask = "";
  
  private String gateway;
  
  private int frequency = 13;
  
  private int smallboradmodel = 0;
  
  private int udpPort = 5554;
  
  private boolean isSocket = false;
  
  private String serialServerIp;
  
  private short serialServerPort = 10029;
  
  private boolean isWriteEthaddr = false;
  
  private String userName = "";
  
  private String passWord = "";
  
  public BoardConfig() {
    if (!ToolUtils.isCmdLine()) {
      String serverIP = getServerIPForBoradIP();
      if (serverIP == null)
        return; 
      String ip = FastbootPreferences.CONFIG.getClientIP();
      if (!IPUtils.isBlank(ip)) {
        this.ip = ip;
      } else if (serverIP.lastIndexOf(".") > 0) {
        String defaultIpAddress = serverIP.substring(0, serverIP.lastIndexOf(".")) + ".0";
        this.ip = defaultIpAddress;
        FastbootPreferences.CONFIG.setClientIP(defaultIpAddress);
      } 
      String gateway = FastbootPreferences.CONFIG.getClientGateway();
      if (!IPUtils.isBlank(gateway)) {
        this.gateway = gateway;
      } else if (pcNetworkInfoList != null) {
        if (pcNetworkInfoList.size() > 0) {
          for (int i = 0; i < pcNetworkInfoList.size(); i++) {
            PCNetworkInfo pcNetworkInfo = pcNetworkInfoList.get(i);
            String localGateway = pcNetworkInfo.getGateway();
            String localIp = pcNetworkInfo.getIp();
            if (serverIP.equalsIgnoreCase(localIp) && 
              localGateway.lastIndexOf(".") > 0) {
              this.gateway = localGateway;
              FastbootPreferences.CONFIG.setClientGateway(localGateway);
            } 
          } 
        } else {
          FastbootPreferences.CONFIG.setClientNetmask(this.subnetMask);
        } 
      } else {
        FastbootPreferences.CONFIG.setClientGateway(this.gateway);
      } 
      String subnetMask = FastbootPreferences.CONFIG.getClientNetmask();
      if (!IPUtils.isBlank(subnetMask)) {
        this.subnetMask = subnetMask;
      } else {
        setNetEnvironment(serverIP);
      } 
      String mac = FastbootPreferences.CONFIG.getClientMac();
      if (IPUtils.isValidMac(mac)) {
        this.mac = mac;
      } else {
        this.mac = IPUtils.generatorMAC();
      } 
    } else {
      String serverIP = getServerIPForBoradIP();
      com.vendor.burn.model.BoardConfig boardConfig = BurnConfig.getBoardConfig();
      if (serverIP == null || boardConfig == null)
        return; 
      String ip = boardConfig.getIp();
      String gateway = boardConfig.getGateway();
      String subnetMask = boardConfig.getSubnetMask();
      String mac = boardConfig.getMac();
      initIP(serverIP, ip);
      initGateway(serverIP, gateway);
      initSubnetMask(serverIP, subnetMask);
      initMac(mac);
    } 
  }
  
  private void setNetEnvironment(String serverIP) {
    if (pcNetworkInfoList != null) {
      if (pcNetworkInfoList.size() > 0) {
        for (int i = 0; i < pcNetworkInfoList.size(); i++) {
          PCNetworkInfo pcNetworkInfo = pcNetworkInfoList.get(i);
          String localSubnetMask = pcNetworkInfo.getSubnetMask();
          String localIp = pcNetworkInfo.getIp();
          if (serverIP.equalsIgnoreCase(localIp) && 
            localSubnetMask.lastIndexOf(".") > 0) {
            this.subnetMask = localSubnetMask;
            FastbootPreferences.CONFIG.setClientNetmask(localSubnetMask);
          } 
        } 
      } else {
        FastbootPreferences.CONFIG.setClientNetmask(this.subnetMask);
      } 
    } else {
      FastbootPreferences.CONFIG.setClientNetmask(this.subnetMask);
    } 
  }
  
  private void initMac(String mac) {
    if (IPUtils.isValidMac(mac)) {
      this.mac = mac;
    } else {
      this.mac = IPUtils.generatorMAC();
    } 
  }
  
  private void initSubnetMask(String serverIP, String subnetMask) {
    if (!IPUtils.isBlank(subnetMask)) {
      this.subnetMask = subnetMask;
    } else if (pcNetworkInfoList != null && 
      pcNetworkInfoList.size() > 0) {
      for (int i = 0; i < pcNetworkInfoList.size(); i++) {
        PCNetworkInfo pcNetworkInfo = pcNetworkInfoList.get(i);
        String localSubnetMask = pcNetworkInfo.getSubnetMask();
        String localIp = pcNetworkInfo.getIp();
        if (serverIP.equalsIgnoreCase(localIp) && 
          localSubnetMask.lastIndexOf(".") > 0)
          this.subnetMask = localSubnetMask; 
      } 
    } 
  }
  
  private void initGateway(String serverIP, String gateway) {
    if (!IPUtils.isBlank(gateway)) {
      this.gateway = gateway;
    } else if (pcNetworkInfoList != null && 
      pcNetworkInfoList.size() > 0) {
      for (int i = 0; i < pcNetworkInfoList.size(); i++) {
        PCNetworkInfo pcNetworkInfo = pcNetworkInfoList.get(i);
        String localGateway = pcNetworkInfo.getGateway();
        String localIp = pcNetworkInfo.getIp();
        if (serverIP.equalsIgnoreCase(localIp) && 
          localGateway.lastIndexOf(".") > 0)
          this.gateway = localGateway; 
      } 
    } 
  }
  
  private void initIP(String serverIP, String ip) {
    if (!IPUtils.isBlank(ip)) {
      this.ip = ip;
    } else if (serverIP.lastIndexOf(".") > 0) {
      String defaultIpAddress = serverIP.substring(0, serverIP.lastIndexOf(".")) + ".0";
      this.ip = defaultIpAddress;
    } 
  }
  
  private String getServerIPForBoradIP() {
    String serverIp = null;
    String configServerIP = null;
    if (!ToolUtils.isCmdLine()) {
      configServerIP = FastbootPreferences.CONFIG.getServerIP();
    } else if (BurnConfig.getLocalConfig() != null) {
      configServerIP = BurnConfig.getLocalConfig().getServerIp();
    } 
    String[] serverIps = IPUtils.getServerIps();
    if (IPUtils.isValidIP(configServerIP)) {
      if (Arrays.<String>asList(serverIps).contains(configServerIP)) {
        serverIp = configServerIP;
      } else if (serverIps.length > 0) {
        serverIp = serverIps[0];
      } 
    } else {
      try {
        serverIp = InetAddress.getLocalHost().getHostAddress();
      } catch (UnknownHostException e) {
        if (serverIps.length > 0)
          serverIp = serverIps[0]; 
      } 
    } 
    return serverIp;
  }
  
  public String getGateway() {
    return this.gateway;
  }
  
  public String getIp() {
    return this.ip;
  }
  
  public String getMac() {
    return this.mac;
  }
  
  public String getSubnetMask() {
    return this.subnetMask;
  }
  
  public void setGateway(String gateway) {
    this.gateway = gateway;
  }
  
  public void setIp(String ip) {
    this.ip = ip;
  }
  
  public void setMac(String mac) {
    this.mac = mac;
  }
  
  public void setSubnetMask(String subnetMask) {
    this.subnetMask = subnetMask;
  }
  
  public int getUdpPort() {
    return this.udpPort;
  }
  
  public void setUdpPort(int port) {
    this.udpPort = port;
  }
  
  public static List<com.vendor.burn.model.BoardConfig> load() {
    List<com.vendor.burn.model.BoardConfig> boardConfigs = new ArrayList<>();
    String[] config = FastbootPreferences.CONFIG.getClientWholeConfig().split(";");
    com.vendor.burn.model.BoardConfig convert = null;
    for (String string : config) {
      convert = convert(string);
      if (convert != null)
        boardConfigs.add(convert); 
    } 
    return boardConfigs;
  }
  
  public static String save(List<com.vendor.burn.model.BoardConfig> boardConfigs) {
    StringBuilder sb = new StringBuilder();
    for (com.vendor.burn.model.BoardConfig boardConfig : boardConfigs) {
      if (sb.length() > 0)
        sb.append(";"); 
      sb.append(boardConfig.toString());
    } 
    return sb.toString();
  }
  
  public static com.vendor.burn.model.BoardConfig convert(String setting) {
    String[] value = setting.split(",");
    if (value.length != 4)
      return null; 
    com.vendor.burn.model.BoardConfig boardConfig = new com.vendor.burn.model.BoardConfig();
    boardConfig.setMac(value[0]);
    boardConfig.setIp(value[1]);
    boardConfig.setSubnetMask(value[2]);
    boardConfig.setGateway(value[3]);
    return boardConfig;
  }
  
  public int getFrequency() {
    return this.frequency;
  }
  
  public void setFrequency(int frequency) {
    this.frequency = frequency;
  }
  
  public int getSmallboradmodel() {
    return this.smallboradmodel;
  }
  
  public void setSmallboradmodel(int smallboradmodel) {
    this.smallboradmodel = smallboradmodel;
  }
  
  public boolean isSocket() {
    return this.isSocket;
  }
  
  public void setSocket(boolean isSocket) {
    this.isSocket = isSocket;
  }
  
  public String getSerialServerIp() {
    return this.serialServerIp;
  }
  
  public void setSerialServerIp(String setSerialServerIp) {
    this.serialServerIp = setSerialServerIp;
  }
  
  public short getSerialServerPort() {
    return this.serialServerPort;
  }
  
  public void setSerialServerPort(short serialServerPort) {
    this.serialServerPort = serialServerPort;
  }
  
  public String getUserName() {
    return this.userName;
  }
  
  public void setUserName(String userName) {
    this.userName = userName;
  }
  
  public String getPassWord() {
    return this.passWord;
  }
  
  public void setPassWord(String passWord) {
    this.passWord = passWord;
  }
  
  public String toString() {
    return this.mac + "," + this.mac + "," + this.ip + "," + this.subnetMask;
  }
  
  public boolean isWriteEthaddr() {
    return this.isWriteEthaddr;
  }
  
  public void setWriteEthaddr(boolean isWriteEthaddr) {
    this.isWriteEthaddr = isWriteEthaddr;
  }
}
